package dev.shadowsoffire.apotheosis.adventure.socket;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.core.RegistryAccess;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;

public class UnnamingRecipe extends AdventureModule.ApothSmithingRecipe {
  private static final ResourceLocation ID = new ResourceLocation("apotheosis:unnaming");
  
  public UnnamingRecipe() {
    super(ID, Ingredient.f_43901_, Ingredient.m_43929_(new ItemLike[] { (ItemLike)Adventure.Items.SIGIL_OF_UNNAMING.get() }, ), ItemStack.f_41583_);
  }
  
  public boolean m_5818_(Container pInv, Level pLevel) {
    ItemStack base = pInv.m_8020_(1);
    if (base.m_41619_())
      return false; 
    CompoundTag afxData = base.m_41737_("affix_data");
    boolean hasName = (afxData != null && afxData.m_128425_("name", 8));
    return (hasName && pInv.m_8020_(2).m_41720_() == Adventure.Items.SIGIL_OF_UNNAMING.get());
  }
  
  public ItemStack m_5874_(Container pInv, RegistryAccess regs) {
    ItemStack out = pInv.m_8020_(1).m_41777_();
    CompoundTag afxData = out.m_41737_("affix_data");
    DynamicHolder<LootRarity> rarity = AffixHelper.getRarity(afxData);
    if (afxData == null || !rarity.isBound())
      return ItemStack.f_41583_; 
    MutableComponent mutableComponent = Component.m_237110_("%2$s", new Object[] { "", "" }).m_130948_(Style.f_131099_.m_131148_(((LootRarity)rarity.get()).getColor()));
    AffixHelper.setName(out, (Component)mutableComponent);
    return out;
  }
  
  public RecipeSerializer<?> m_7707_() {
    return (RecipeSerializer<?>)Serializer.INSTANCE;
  }
  
  public RecipeType<?> m_6671_() {
    return RecipeType.f_44113_;
  }
  
  public boolean m_5598_() {
    return true;
  }
}
